package utopp;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * Title:        U-Topp: Projekt des ProPra WS 2000/2001
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Makrosoft
 * @author Makrosoft
 * @version 1.0
 */

public class Klasseneingabemaske extends JDialog implements ActionListener {

  //  Attribute

  AddDialog addDialog;
  DeleteDialog deleteDialog;
  String[] auswahlSichtbarkeit = { "public", "protected", "private", "" };
  Vector attributeListInhalt;
  Vector methodenListInhalt;
  ActionListener al;
  Klasse klasse;

  // AllgemeinPanel

  JTabbedPane kontainerFuer = new JTabbedPane();
  JPanel allgemeinPanel = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel attributePanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel methodenPanel = new JPanel();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel zusicherungenLabel = new JLabel();
  JLabel sterotypLabel = new JLabel();
  JLabel paketLabel = new JLabel();
  JLabel nameLabel = new JLabel();
  JTextField nameFeld = new JTextField();
  JTextField paketFeld = new JTextField();
  JTextField sterotypFeld = new JTextField();
  JTextField zusicherungenFeld = new JTextField();
  JButton fertigButton = new JButton();

  // AtributePanel

  JButton deleteAttributButton = new JButton();
  JButton attributeRechtsButton = new JButton();
  JButton addAttributButton = new JButton();
  JScrollPane attributeListPanel = new JScrollPane();
  JList attributeList = new JList();
  JButton attributeLinksButton = new JButton();
  JLabel attributeNameLabel = new JLabel();
  JLabel attributeTypLabel = new JLabel();
  JLabel attributeInitialwertLabel = new JLabel();
  JLabel attributeSichtbarkeitLabel = new JLabel();
  JLabel attributeZusicherungenLabel = new JLabel();
  JTextField attributeNameFeld = new JTextField();
  JTextField attributeTypFeld = new JTextField();
  JTextField attributeInitialwertFeld = new JTextField();
  JTextField attributeZusicherungenFeld = new JTextField();
  JComboBox attributeSichtbarkeitFeld = new JComboBox(auswahlSichtbarkeit);

  // MethodenPanel

  JButton deleteMethodenButton = new JButton();
  JButton methodenRechtsButton = new JButton();
  JButton addMethodenButton = new JButton();
  JScrollPane methodenListPanel = new JScrollPane();
  JList methodenList = new JList();
  JButton methodenLinksButton = new JButton();
  JLabel methodenNameLabel = new JLabel();
  JLabel methodenRueckgabetypLabel = new JLabel();
  JLabel methodenArgumenteLabel = new JLabel();
  JLabel methodenSichtbarkeitLabel = new JLabel();
  JLabel methodenZusicherungenLabel = new JLabel();
  JTextField methodenNameFeld = new JTextField();
  JTextField methodenRueckgabetypFeld = new JTextField();
  JTextField methodenArgumenteFeld = new JTextField();
  JTextField methodenZusicherungenFeld = new JTextField();
  JComboBox methodenSichtbarkeitFeld = new JComboBox(auswahlSichtbarkeit);


  public Klasseneingabemaske(Klasse k, ActionListener a) {

    al = a;
    klasse = k;

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  private void jbInit() throws Exception {





    this.setModal(true);
    this.setTitle("Klasseneingabemaske");
    this.setResizable(false);
    this.getContentPane().setLayout(gridLayout1);

    // AllgemeinPanel

    allgemeinPanel.setLayout(gridBagLayout2);
    zusicherungenLabel.setText("Zusicherungen:");
    sterotypLabel.setText("stereotyp:");
    paketLabel.setText("Paket:");
    nameLabel.setText("Name:");
    fertigButton.setText("fertig");
    fertigButton.setActionCommand("klassenmaske fertig");
    fertigButton.addActionListener(al);

    //AttributePanel

    attributePanel.setLayout(gridBagLayout1);
    deleteAttributButton.setText("delete Attribut");
    deleteAttributButton.addActionListener(this);
    attributeRechtsButton.setText(">>");
    attributeRechtsButton.addActionListener(this);
    attributeRechtsButton.setActionCommand("attribut nach rechts");
    addAttributButton.setText("add Attribut");
    addAttributButton.addActionListener(this);
    attributeLinksButton.setText("<<");
    attributeLinksButton.addActionListener(this);
    attributeLinksButton.setActionCommand("attribut nach links");
    attributeNameLabel.setText("Name:");
    attributeTypLabel.setText("Typ:");
    attributeInitialwertLabel.setText("Initialwert:");
    attributeSichtbarkeitLabel.setText("Sichtbarkeit:");
    attributeZusicherungenLabel.setText("Zusicherungen:");
    attributeListPanel.getViewport().setBackground(Color.white);
    attributeListPanel.setPreferredSize(new Dimension(100, 150));
    attributeList.setPreferredSize(new Dimension(185, 60));
    attributeList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    // MehtodenPanel

    methodenPanel.setLayout(gridBagLayout3);
    deleteMethodenButton.setText("delete Methode");
    deleteMethodenButton.addActionListener(this);
    methodenRechtsButton.setText(">>");
    methodenRechtsButton.addActionListener(this);
    methodenRechtsButton.setActionCommand("methode nach rechts");
    addMethodenButton.setText("add Methode");
    addMethodenButton.addActionListener(this);
    methodenLinksButton.setText("<<");
    methodenLinksButton.addActionListener(this);
    methodenLinksButton.setActionCommand("methode nach links");
    methodenNameLabel.setText("Name:");
    methodenRueckgabetypLabel.setText("Rckgabetyp:");
    methodenArgumenteLabel.setText("Argumente:");
    methodenSichtbarkeitLabel.setText("Sichtbarkeit:");
    methodenZusicherungenLabel.setText("Zusicherungen:");
     methodenListPanel.getViewport().setBackground(Color.white);
    methodenPanel.setPreferredSize(new Dimension(572, 514));
    methodenList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    this.getContentPane().add(kontainerFuer, null);



    kontainerFuer.add(allgemeinPanel, "Allgemeines");

    nameFeld.setText(klasse.get_name());
    paketFeld.setText(klasse.get_paket());
    sterotypFeld.setText(klasse.get_stereotyp());
    zusicherungenFeld.setText(klasse.get_zusicherungen());


    allgemeinPanel.add(nameLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    allgemeinPanel.add(paketLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    allgemeinPanel.add(sterotypLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    allgemeinPanel.add(zusicherungenLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    allgemeinPanel.add(nameFeld, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 10), 0, 8));
    allgemeinPanel.add(paketFeld, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 10), 0, 8));
    allgemeinPanel.add(sterotypFeld, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 10), 0, 8));
    allgemeinPanel.add(zusicherungenFeld, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 10), 0, 8));
    allgemeinPanel.add(fertigButton, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(25, 25, 25, 25), 10, 10));


    kontainerFuer.add(attributePanel, "Attribute");

    attributeListInhalt = new Vector();
    for (int i=0; i < klasse.anzahl_Attribute; i++) {
      attributeListInhalt.add(klasse.getAttribut(i).getName());
    }
    attributeList.setListData(attributeListInhalt);


    attributeListPanel.add(attributeList);
    attributeListPanel.getViewport().setView(attributeList);
    attributePanel.add(attributeListPanel, new GridBagConstraints(0, 0, 1, 5, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(25, 25, 25, 25), 0, 0));
    attributePanel.add(addAttributButton, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 25, 10, 25), 0, 0));
    attributePanel.add(deleteAttributButton, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 25, 25, 25), 0, 0));
    attributePanel.add(attributeRechtsButton, new GridBagConstraints(1, 0, 1, 3, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(105, 10, 10, 10), 0, 0));
    attributePanel.add(attributeLinksButton, new GridBagConstraints(1, 3, 1, 2, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 120, 10), 0, 0));
    attributePanel.add(attributeNameLabel, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    attributePanel.add(attributeTypLabel, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    attributePanel.add(attributeSichtbarkeitLabel, new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    attributePanel.add(attributeInitialwertLabel, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    attributePanel.add(attributeZusicherungenLabel, new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    attributePanel.add(attributeNameFeld, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 25), 125, 8));
    attributePanel.add(attributeTypFeld, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 25), 125, 8));
    attributePanel.add(attributeInitialwertFeld, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 25), 125, 8));
    attributePanel.add(attributeZusicherungenFeld, new GridBagConstraints(3, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(25, 10, 35, 25), 125, 8));
    attributePanel.add(attributeSichtbarkeitFeld, new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 25), 125, 8));



    kontainerFuer.add(methodenPanel, "Methoden");


    methodenListInhalt = new Vector();
    for (int i=0; i < klasse.anzahl_Methoden; i++) {
      methodenListInhalt.add(klasse.get_Methode(i).getName());
    }
    methodenList.setListData(methodenListInhalt);

    methodenListPanel.add(methodenList);
    methodenListPanel.getViewport().setView(methodenList);
    methodenPanel.add(methodenListPanel, new GridBagConstraints(0, 0, 1, 5, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(25, 25, 25, 25), 0, 0));
    methodenPanel.add(addMethodenButton, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 25, 10, 25), 0, 0));
    methodenPanel.add(deleteMethodenButton, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 25, 25, 25), 0, 0));
    methodenPanel.add(methodenRechtsButton, new GridBagConstraints(1, 0, 1, 3, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(105, 10, 10, 10), 0, 0));
    methodenPanel.add(methodenLinksButton, new GridBagConstraints(1, 3, 1, 2, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 120, 10), 0, 0));
    methodenPanel.add(methodenNameLabel, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    methodenPanel.add(methodenRueckgabetypLabel, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    methodenPanel.add(methodenSichtbarkeitLabel, new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    methodenPanel.add(methodenArgumenteLabel, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    methodenPanel.add(methodenZusicherungenLabel, new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(25, 10, 25, 10), 0, 0));
    methodenPanel.add(methodenNameFeld, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 25), 125, 8));
    methodenPanel.add(methodenRueckgabetypFeld, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 25), 125, 8));
    methodenPanel.add(methodenArgumenteFeld, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 25), 125, 8));
    methodenPanel.add(methodenZusicherungenFeld, new GridBagConstraints(3, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 35, 25), 125, 8));
    methodenPanel.add(methodenSichtbarkeitFeld, new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(25, 10, 25, 25), 125, 8));

    addWindowListener( new WindowAdapter() {
                                  public void windowClosing(WindowEvent e) {
                                    setVisible(false);
                                    dispose();
                                  }
                          } );
  }

  public void actionPerformed(ActionEvent e) {
    String cmd = e.getActionCommand();
    if (cmd.equals("add Methode")) {
      addMethode();
    } else if (cmd.equals("delete Methode")) {
      deleteMethode();
    } else if (cmd.equals("methode nach links")) {
      methodeNachLinks();
    } else if (cmd.equals("methode nach rechts")) {
      methodeNachRechts();
    } else if (cmd.equals("add Attribut")) {
      addAttribut();
    } else if (cmd.equals("delete Attribut")) {
      deleteAttribut();
    } else if (cmd.equals("attribut nach links")) {
      attributNachLinks();
    } else if (cmd.equals("attribut nach rechts")) {
      attributNachRechts();
    } else if (cmd.equals("addDialog ok")) {
      addDialogOk();
    } else if (cmd.equals("addDialog abbrechen")) {
      addDialogAbbrechen();
    } else if (cmd.equals("deleteDialog ja")) {
      deleteDialogJa();
    } else if (cmd.equals("deleteDialog nein")) {
      deleteDialogNein();
    }
  }

  void addMethode() {
    addDialog = new AddDialog("Methode hinzufgen", this);
    addDialog.setLocation(300, 300);
    addDialog.setVisible(true);
  }

  void deleteMethode() {
    if (! methodenList.isSelectionEmpty()) {
      deleteDialog = new DeleteDialog("Methode lschen", "die Methode "+
                          (String) methodenListInhalt.elementAt(methodenList.getSelectedIndex()), this);
      deleteDialog.setLocation(300, 300);
      deleteDialog.setVisible(true);
    }
  }

  void methodeNachLinks() {
    if (! methodenList.isSelectionEmpty()) {
      int index = methodenList.getSelectedIndex();
      methodenListInhalt.removeElementAt( index );
      methodenListInhalt.add(index, methodenNameFeld.getText());
      methodenList.setListData(methodenListInhalt);
      methodenListPanel.getViewport().setView(methodenList);
      Methode m = klasse.get_Methode( index );
      m.setName(methodenNameFeld.getText());
      m.set_typ(methodenRueckgabetypFeld.getText());
      m.set_Parameter(methodenArgumenteFeld.getText());
      m.set_Zusicherungen(methodenZusicherungenFeld.getText());
      m.set_Sichtbarkeit((String) methodenSichtbarkeitFeld.getSelectedItem());
    }
  }

  void methodeNachRechts() {
    if (! methodenList.isSelectionEmpty()) {
      int index = methodenList.getSelectedIndex();
      Methode m = klasse.get_Methode( index );
      methodenNameFeld.setText(m.getName());
      methodenRueckgabetypFeld.setText(m.get_typ());
      methodenArgumenteFeld.setText(m.get_Parameter());
      methodenZusicherungenFeld.setText(m.get_Zusicherungen());
      methodenSichtbarkeitFeld.setSelectedItem(m.get_Sichtbarkeit());
    }
  }

  void addAttribut() {
    addDialog = new AddDialog("Attribut hinzufgen", this);
    addDialog.setLocation(300, 300);
    addDialog.setVisible(true);
  }

  void deleteAttribut() {
    if (! attributeList.isSelectionEmpty()) {
      deleteDialog = new DeleteDialog("Attribut lschen", "das Attribut "+
                          (String) attributeListInhalt.elementAt(attributeList.getSelectedIndex()), this);
      deleteDialog.setLocation(300,300);
      deleteDialog.setVisible(true);
    }
  }

  void attributNachLinks() {
    if (! attributeList.isSelectionEmpty()) {
        int index = attributeList.getSelectedIndex();
        attributeListInhalt.removeElementAt( index );
        attributeListInhalt.add(index, attributeNameFeld.getText());
        attributeList.setListData(attributeListInhalt);
        attributeListPanel.getViewport().setView(attributeList);
        Attribut m = klasse.getAttribut( index );
        m.setName(attributeNameFeld.getText());
        m.setTyp(attributeTypFeld.getText());
        m.setInitialwert(attributeInitialwertFeld.getText());
        m.setZusicherung(attributeZusicherungenFeld.getText());
        m.setSichtbarkeit((String) attributeSichtbarkeitFeld.getSelectedItem());
    }
  }

  void attributNachRechts() {
    if (! attributeList.isSelectionEmpty()) {
      int index = attributeList.getSelectedIndex();
      Attribut m = klasse.getAttribut( index );
      attributeNameFeld.setText(m.getName());
      attributeTypFeld.setText(m.getTyp());
      attributeInitialwertFeld.setText(m.getInitialwert());
      attributeZusicherungenFeld.setText(m.getZusicherung());
      attributeSichtbarkeitFeld.setSelectedItem(m.getSichtbarkeit());
    }
  }

  void addDialogOk() {
    addDialog.setVisible(false);
    if (addDialog.getTitle().equals("Attribut hinzufgen")) {
      attributeListInhalt.add(addDialog.nameFeld.getText());
      attributeList.setListData(attributeListInhalt);
      attributeListPanel.getViewport().setView(attributeList);
      Attribut neuesAttribut = new Attribut(addDialog.nameFeld.getText(), "", "", "", "");
      klasse.add_attribut(neuesAttribut);
    } else if (addDialog.getTitle().equals("Methode hinzufgen")) {
      methodenListInhalt.add(addDialog.nameFeld.getText());
      methodenList.setListData(methodenListInhalt);
      methodenListPanel.getViewport().setView(methodenList);
      Methode neueMethode = new Methode(addDialog.nameFeld.getText(), "", "", "", "");
      klasse.add_methode(neueMethode);
    }
    addDialog.dispose();

  }

  void addDialogAbbrechen() {
    addDialog.setVisible(false);
    addDialog.dispose();
  }

  void deleteDialogJa() {
    deleteDialog.setVisible(false);
    if (deleteDialog.getTitle().equals("Attribut lschen")) {
      int index = attributeList.getSelectedIndex();
      klasse.delete_Attribut(index);
      attributeListInhalt.removeElementAt( index );
      attributeList.setListData(attributeListInhalt);
      attributeListPanel.getViewport().setView(attributeList);
    } else if (deleteDialog.getTitle().equals("Methode lschen")) {
      int index = methodenList.getSelectedIndex();
      klasse.delete_Methode(index);
      methodenListInhalt.removeElementAt(index);
      methodenList.setListData(methodenListInhalt);
      methodenListPanel.getViewport().setView(methodenList);
    }
    deleteDialog.dispose();
  }

  void deleteDialogNein() {
    deleteDialog.setVisible(false);
    deleteDialog.dispose();
  }

}